#include <iostream>
#include <vector>

using namespace std;

int nod(int a, int b) {
    while (b > 0) {
        a = a % b;
        swap(a, b);
    }
    return a;
}


vector<vector<double>> sort(vector<vector<double>> target) {
    vector <vector<double>> temp_left, temp_right, temp_mid,res;
    for (int i=1; i<target.size();i++) {
        if ((target[i][0] / target[i][1]) > target[0][0] / target[0][1]) { temp_right.push_back(target[i]);}
        if ((target[i][0] / target[i][1]) < target[0][0] / target[0][1]) { temp_left.push_back(target[i]);}
        if ((target[i][0] / target[i][1]) == target[0][0] / target[0][1]) { temp_mid.push_back(target[i]);}
    }
    temp_mid.push_back(target[0]);
    if (!temp_left.empty()){
        vector <vector<double>> part_res;
        part_res = sort(temp_left);
        for (int i=0; i<part_res.size();i++) res.push_back(part_res[i]);
    }
    if (!temp_mid.empty()){
        for (int i=0; i<temp_mid.size();i++) res.push_back(temp_mid[i]);
    }
    if (!temp_right.empty()){
        vector <vector<double>> part_res;
        part_res = sort(temp_right);
        for (int i=0; i<part_res.size();i++) res.push_back(part_res[i]);
    }
    return res;
}


int main() {
    int n;cin >> n;
    int q;cin >> q;
    int a[n];for (int i=0; i<n ;i++) cin >> a[i];
    int b[n];for (int i=0; i<n ;i++) cin >> b[i];
    vector <vector <double>> res;
    double nod_val;
    for (int i=0; i<n ;i++) {
        for (int j = 0; j < n; j++){
            nod_val = nod(a[i],b[j]);
            vector <double> temp;
            temp.push_back(a[i] / nod_val);
            temp.push_back(b[j] / nod_val);
            res.push_back(temp);
    }}

    res = sort(res);


    int x;
    for (int i =0;i<q;i++){
        cin >> x;
        cout<<res[x-1][0] << " " << res[x-1][1] << "\n";}
    return 0;
}

